using System;

namespace ParalelPortApp2
{
	/// <summary>
	/// Summary description for ButtonArray.
	/// </summary>
	public class ButtonArray :System.Collections.CollectionBase
	{
		private readonly System.Windows.Forms.GroupBox hostBox;
		private int baseadres=0x378;
		
		public ButtonArray(System.Windows.Forms.GroupBox host,int i)
		{
			hostBox=host;
			
			if(i==1)
				for(int k=0;k<4;k++){
					this.AddNewButtonC();}
			else{for(int k=0;k<8;k++)
				this.AddNewButtonD();}

		}
		public NewButton AddNewButtonC()
		{
			NewButton aButton=new NewButton();
			aButton.Click+=new System.EventHandler(ClickHandlerC);
			this.List.Add(aButton);
			hostBox.Controls.Add(aButton);
			aButton.Top=40;
			aButton.Width=50;
			aButton.Status=false;
			aButton.Tag=this.Count;
			aButton.BackColor=System.Drawing.Color.White;
			aButton.Left=230-50*(Count);
			aButton.Text="C "+this.Count.ToString();

			return aButton;
		}
		public NewButton AddNewButtonD()
		{
			NewButton aButton=new NewButton();
			aButton.Click+=new System.EventHandler(ClickHandlerD);
			this.List.Add(aButton);
			hostBox.Controls.Add(aButton);
			aButton.Top=40;
			aButton.Left=370-45*(Count);
			aButton.Width=45;
			aButton.Status=false;
			aButton.Tag=this.Count;
			aButton.BackColor=System.Drawing.Color.White;
			aButton.Text="D "+this.Count.ToString();

			return aButton;
		}
		public System.Windows.Forms.Button AddNewButton()
		{
			System.Windows.Forms.Button aButton=new System.Windows.Forms.Button();
			aButton.Click+=new System.EventHandler(ClickHandler);
			this.List.Add(aButton);
			hostBox.Controls.Add(aButton);
			aButton.Top=40;
			aButton.Left=150-35*(Count);
			aButton.Width=35;
			
			aButton.Tag=this.Count;
			aButton.BackColor=System.Drawing.Color.White;
			aButton.Text="C "+this.Count.ToString();

			return aButton;
		}
		
		

		public NewButton this [int Index]
		{
			get{return (NewButton)this.List[Index];}

		}
		public void ClickHandler(Object sender, System.EventArgs e)
		{
			System.Windows.Forms.MessageBox.Show("You have clicked button " 
				+((System.Windows.Forms.Button) sender).Tag.ToString());
			
			int i=(int)((System.Windows.Forms.Button)sender).Tag;
			
			

		 }

		public void ClickHandlerC(Object sender, System.EventArgs e)
		{
			int i=(int)((NewButton)sender).Tag;
			InpOut.ToggleControlPortBit(baseadres,i-1);
			if(((NewButton)sender).Status==false)
			{ 
				
				((NewButton)sender).Status=true ;
				((NewButton)sender).BackColor=System.Drawing.Color.Red;
				
			}
			else
			{
				
				((NewButton)sender).Status=false;
				((NewButton)sender).BackColor=System.Drawing.Color.White;

			}
			

		}

		public void ClickHandlerD(Object sender, System.EventArgs e)
		{/*
			System.Windows.Forms.MessageBox.Show("You have clicked button " 
				+((NewButton) sender).Tag.ToString());
			*/
			int i=(int)((NewButton)sender).Tag;
			InpOut.ToggleDataPortBit(baseadres,i-1);
			if(((NewButton)sender).Status==false)
			{ 
				
				((NewButton)sender).Status=true ;
				((NewButton)sender).BackColor=System.Drawing.Color.Red;
				
			}
			else
			{
				
				((NewButton)sender).Status=false;
				((NewButton)sender).BackColor=System.Drawing.Color.White;

			}
			
		}
	}

	
}
